program spoku_pils;

{ LIO'99 uzdevums par izkanu no spoku pils, ja katr istab nordts sou skaits,
 par cik prvietos.

  1999, Mrti Opmanis}

 type
  raksts = record
            vertiba : shortint;
            pazime  : byte;
           end;

  koord = record
           iko,jko,paz : byte;
          end;

  mas_tips = array [0..1] of koord;

 const
  p : array[1..8] of byte = (1, 2, 4, 8, 16, 32, 64, 128);
  max_porcijas = 4;
  mas_porcija = 10000;
  mas_max = max_porcijas * mas_porcija - 1;

 var
  a : array [1..100,1..100] of raksts;
  mas : array [1..2,0..max_porcijas-1] of ^mas_tips;
  aizpildits : array [1..2] of word;
  jaunais_ind, vecais_ind : byte;
  solu_sk : integer;
  atrasts : boolean;
  i, j, n, m : shortint;
  ii, jj : integer;
  f_dat, f_rez : Text;

 label
  laukaa;



 procedure Parbaudi(i, j : shortint; k: byte);
 {Pievieno vl neapskatto sarakst}
  begin
   if aizpildits[jaunais_ind]<mas_max
    then
     begin
      Inc(aizpildits[jaunais_ind]);
      with mas[jaunais_ind, aizpildits[jaunais_ind] div mas_porcija]^[aizpildits[jaunais_ind] mod mas_porcija] do
       begin
        iko := i;
        jko := j;
        paz := k;
       end; {with}
     end
    else
     writeln(' PRPILDANS !!!!!!!! ');

  end;



 procedure Pievieno(i, j : shortint; k: byte);
 var ix, v, i_jau, j_jau : shortint;
     b, c, pp : byte;
 label talak;

  begin
   b := a[i,j].pazime;
   if b=255 {visi virzieni jau apskatti}
    then Exit;
   c := 0;
   v := a[i,j].vertiba;

   for ix:=1 to 8 do
    begin
     pp := p[ix];
     if (k<>pp) {td virzien drkstam iet tlk (nav otrreiz pc krtas)}
         and
        (b and pp = 0) {td vl no ejienes nav iets}
      then
       begin
        c := c or pp;
        case ix of
         1,2,8 : if (i+v<=n) then i_jau := i+v else goto talak;
         4..6  : if (i>v)    then i_jau := i-v else goto talak;
         else i_jau := i;
        end; {case}

        case ix of
         2..4 : if (j+v<=m) then j_jau := j+v else goto talak;
         6..8 : if (j>v)    then j_jau := j-v else goto talak;
         else j_jau := j;
        end; {case}

        {Prbauds tikai tad, ja var dot ko jaunu}
         if (a[i_jau,j_jau].pazime or pp) < 255 then Parbaudi(i_jau,j_jau,pp);
        talak:;

       end;
    end; {do ix}

   a[i,j].pazime := b or c; {Pievieno informciju par tikko apskattajiem}

  end; {Pievieno}



  begin
   atrasts := false;

   for ii:=1 to 2 do
    for jj:=0 to max_porcijas-1 do
    begin
     GetMem(mas[ii,jj],mas_porcija*sizeof(koord));
     aizpildits[ii] := 0;
    end;

   jaunais_ind := 1;
   solu_sk := 0;


   Assign(f_dat,'PILS.DAT');
   Reset(f_dat);
   Readln(f_dat,n,m);
   for j:=1 to m do
    begin
     for i:=1 to n-1 do begin Read(f_dat,a[i,j].vertiba); a[i,j].pazime := 0; end;
     Readln(f_dat,a[n,j].vertiba);
     a[n,j].pazime := 0;
    end;
   Close(f_dat);


   Parbaudi(1,1,0);

   while (aizpildits[jaunais_ind]>0) and (a[n,m].pazime=0) do
    begin
     vecais_ind := jaunais_ind;
     jaunais_ind := 3 - vecais_ind;

     aizpildits[jaunais_ind] := 0;

     for ii:=1 to aizpildits[vecais_ind] do
      with mas[vecais_ind,ii div mas_porcija]^[ii mod mas_porcija] do
       if (iko=n) and (jko=m)
        then
         begin
          atrasts := true;
          goto laukaa;
         end
        else
         Pievieno(iko, jko, paz);

     Inc(solu_sk);
    end; {while}

laukaa :
    Assign(f_rez,'PILS.REZ');
    Rewrite(f_rez);
    if atrasts
     then writeln(f_rez,solu_sk)
     else writeln(f_rez,'NEVAR');
    Close(f_rez);


    for ii:=1 to 2 do
    for jj:=0 to max_porcijas-1 do
     FreeMem(mas[ii,jj],mas_porcija*sizeof(koord));


  end.
